; Copyright (C) Jani Halme

%macro MIDI_program_change 3 ; delta, channel, program
	db	%1
	db	0xc0 | %2
	db	%3
%endmacro

%macro MIDI_note_on 4 ; delta, channel, note, velocity
	db	%1
	db	0x90 | %2
	db	%3
	db	%4
%endmacro

%macro MIDI_note_off 4 ; delta, channel, note velocity
	db	%1
	db	0x80 | %2
	db	%3
	db	%4
%endmacro

%macro MIDI_bank_msb 3
%endmacro

%macro MIDI_bank_lsb 3
%endmacro


; tempo is 120 beats per minute
; when time division (ticks per beat) is 1, delta time 1 is a quarter note
; time division=2 -> delta time 1 is an eigth note

midi_header:
	db	"MThd"
	db	0,0,0,6	;dd 6
	dw	0
	db	0, 1
	db	0, 1

midi_track:
	db	"MTrk"
	dd	0 ; chunklen can be set to zero, midiplayer doesn't care

	MIDI_program_change 0, 0, 21
	MIDI_program_change 0, 1, 86


	; intro
%rep 2
	MIDI_note_on 0, 0, 38, 127

	MIDI_note_on 0, 1, 62, 127
	MIDI_note_on 0, 1, 65, 127

	MIDI_note_off 4, 0, 38, 127

	MIDI_note_off 4, 1, 62, 127
	MIDI_note_off 0, 1, 65, 127

	MIDI_note_on 0, 0, 38, 127
	
	MIDI_note_on 0, 1, 62, 127
	MIDI_note_on 0, 1, 58, 127

	MIDI_note_off 4, 0, 38, 127

	MIDI_note_off 4, 1, 62, 127
	MIDI_note_off 0, 1, 58, 127
%endrep

	; intro, drums
	; pattern 1
	MIDI_note_on 0, 0, 38, 127

	MIDI_note_on 0, 1, 62, 127
	MIDI_note_on 0, 1, 65, 127

	MIDI_note_on 0, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127

	MIDI_note_off 1, 0, 38, 127

	MIDI_note_on 0, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127

	MIDI_note_off 1, 1, 62, 127
	MIDI_note_off 0, 1, 65, 127

	MIDI_note_on 0, 0, 38, 127
	
	MIDI_note_on 0, 1, 62, 127
	MIDI_note_on 0, 1, 58, 127

	MIDI_note_on 0, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127

	MIDI_note_off 1, 0, 38, 127

	MIDI_note_on 0, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127

	MIDI_note_off 1, 1, 62, 127
	MIDI_note_off 0, 1, 58, 127
	; pattern 2
	MIDI_note_on 0, 0, 38, 127

	MIDI_note_on 0, 1, 62, 127
	MIDI_note_on 0, 1, 65, 127

	MIDI_note_on 0, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127

	MIDI_note_off 1, 0, 38, 127

	MIDI_note_on 0, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127

	MIDI_note_off 1, 1, 62, 127
	MIDI_note_off 0, 1, 65, 127

	MIDI_note_on 0, 0, 38, 127
	
	MIDI_note_on 0, 1, 62, 127
	MIDI_note_on 0, 1, 58, 127

	MIDI_note_off 4, 0, 38, 127

	MIDI_note_off 4, 1, 62, 127
	MIDI_note_off 0, 1, 58, 127


	;main
%rep 4
	MIDI_note_on 0, 0, 38, 127

	MIDI_note_on 0, 1, 62, 127
	MIDI_note_on 0, 1, 65, 127

	MIDI_note_on 0, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127

	MIDI_note_off 1, 0, 38, 127

	MIDI_note_on 0, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127

	MIDI_note_off 1, 1, 62, 127
	MIDI_note_off 0, 1, 65, 127

	MIDI_note_on 0, 0, 38, 127
	
	MIDI_note_on 0, 1, 62, 127
	MIDI_note_on 0, 1, 58, 127

	MIDI_note_on 0, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127

	MIDI_note_off 1, 0, 38, 127

	MIDI_note_on 0, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127
	MIDI_note_on 1, 9, 36, 127

	MIDI_note_off 1, 1, 62, 127
	MIDI_note_off 0, 1, 58, 127
%endrep


	; intro again
%rep 2
	MIDI_note_on 0, 0, 38, 127

	MIDI_note_on 0, 1, 62, 127
	MIDI_note_on 0, 1, 65, 127

	MIDI_note_off 4, 0, 38, 127

	MIDI_note_off 4, 1, 62, 127
	MIDI_note_off 0, 1, 65, 127

	MIDI_note_on 0, 0, 38, 127
	
	MIDI_note_on 0, 1, 62, 127
	MIDI_note_on 0, 1, 58, 127

	MIDI_note_off 4, 0, 38, 127

	MIDI_note_off 4, 1, 62, 127
	MIDI_note_off 0, 1, 58, 127
%endrep


	; outro
	MIDI_note_on 0, 0, 38, 127

	MIDI_note_off 4, 0, 38, 127

	MIDI_note_on 4, 0, 38, 127
	
	MIDI_note_off 4, 0, 38, 127

midi_track_end:

