; Copyright (C) Teemu Suutari

	[section .bss]
	align 16
nsopenglview:
	resb 256
	__SECT__

extern _gl_main_fragment_shader

gl_init:
%ifdef MODE_SWITCHING
	DEBUG "Capture displays"
	LIBCALL _CGCaptureAllDisplays

	DEBUG "Switch display mode"
	pop esi
	push byte 0
	push dword SCREEN_HEIGHT
	push dword SCREEN_WIDTH
	push byte 32
	push byte 0
	pop edi
	pop esi
	pop edx
	pop ecx
	LIBCALL _CGDisplayBestModeForParameters
	xchg eax,esi
	LIBCALL _CGDisplaySwitchToMode
	xor ecx,ecx
%endif

	DEBUG "Start NSApplication"
	LIBCALL _NSApplicationLoad
	DEBUG "Hide Cursor"
	LIBCALL __LATURI_Mangle__$2b$5bNSCursor$20hide$5d ; +[NSCursor hide]


; this enables vsync, but only on fullscreen
%ifdef MODE_SWITCHING
	DEBUG "PixelFormat init"
	LIBCALL __LATURI_Mangle__$2b$5bNSOpenGLView$20defaultPixelFormat$5d ; +[NSOpenGLView defaultPixelFormat]
	xchg eax,edi

	push byte 0
	push byte 0
	push byte 0
	push byte SOLVE(kCGLPFADoubleBuffer) ; double buffering == vsync
	mov edx,esp
	LIBCALL __LATURI_Mangle__$2d$5bNSOpenGLPixelFormat$20initWithAttributes$3a$5d ; -[NSOpenGLPixelFormat initWithAttributes:]
	mov ebp,edi ; 7th parameter for libcall after pushad
%else
	xor ebp,ebp ; 7th parameter for libcall after pushad
%endif
	mov edi,dword _gl_main_fragment_shader ; this will be handy with glShaderSource
	pushad

	DEBUG "Create View"
	GETSYM eax,__LATURI_Mangle__$2eobjc_class_name_SCNImagePackerView
%ifdef NO_LATURI
	mov eax,[eax]
%endif
;	this is wrong, but works (Uses SCNImagePackerView instead of NSOpenGLView)
;	mov eax,[byte eax+4]
	mov edi,dword nsopenglview
	mov [edi],eax
	LIBCALL __LATURI_Mangle__$2d$5bNSOpenGLView$20initWithFrame$3apixelFormat$3a$5d ; -[NSOpenGLView initWithFrame:pixelFormat:]
	LIBCALL __LATURI_Mangle__$2b$5bNSScreen$20mainScreen$5d ; +[NSScreen mainScreen]
	xchg eax,edx
%ifdef NO_LATURI
	; laturi has ecx=0 on start
	xor ecx,ecx
%endif
	LIBCALL __LATURI_Mangle__$2d$5bNSView$28NSFullScreenMode$29$20enterFullScreenMode$3awithOptions$3a$5d ; -[NSView(NSFullScreenMode) enterFullScreenMode:withOptions:]

	DEBUG "Initializing shader"
	mov edi,SOLVE(GL_FRAGMENT_SHADER)
	GL_LIBCALL _glCreateShader
	xchg eax,edi
	push byte 1
	pop esi
	; [esp] = _gl_main_fragment_shader
	mov edx,esp
;	ecx = 0
	GL_LIBCALL _glShaderSource
	GL_LIBCALL _glCompileShader

	mov esi,edi
	GL_LIBCALL _glCreateProgram
	xchg eax,edi
	GL_LIBCALL _glAttachShader
	GL_LIBCALL _glLinkProgram
	GL_LIBCALL _glUseProgram

;	DEBUG "VSync"
;	LIBCALL __LATURI_Mangle__$2b$5bNSOpenGLContext$20currentContext$5d ;+[NSOpenGLContext currentContext]
;	xchg eax,edi
;	mov ecx,222 ;SOLVE(NSOpenGLCPSwapInterval)
;	LIBCALL __LATURI_Mangle__$2d$5bNSOpenGLContext$20setValues$3aforParameter$3a$5d ; -[NSOpenGLContext setValues:forParameter:]
;	xor ecx,ecx


	DEBUG "GL init done"
gl_init_end:
